## libpillowfight 0.2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(libpillowfight)
set(CMAKE_BUILD_TYPE Release)
set(LIBDIR lib CACHE STRING "object code libraries directory")

add_definitions(-DNO_PYTHON)
include_directories(include)

add_library(pillowfight SHARED
    src/pillowfight/_ace.c
    src/pillowfight/_blackfilter.c
    src/pillowfight/_blurfilter.c
    src/pillowfight/_border.c
    src/pillowfight/_canny.c
    src/pillowfight/_compare.c
    src/pillowfight/_gaussian.c
    src/pillowfight/_grayfilter.c
    src/pillowfight/_masks.c
    src/pillowfight/_noisefilter.c
    src/pillowfight/_sobel.c
    src/pillowfight/_version.c
    src/pillowfight/util.c
)

install (TARGETS pillowfight DESTINATION ${LIBDIR})
install (FILES
    include/pillowfight/pillowfight.h
    include/pillowfight/util.h
    DESTINATION
    include/pillowfight
)

=== Makefile ===
# If you want to build in MSYS2 on Windows
# export CMAKE_OPTS=-G "MSYS Makefiles"

VERSION_FILE = src/pillowfight/_version.h
PYTHON = python3

build: build_c build_py

install: install_py install_c

uninstall: uninstall_py

build_py: ${VERSION_FILE}
	${PYTHON} ./setup.py build

build_c: ${VERSION_FILE} build/libpillowfight.so

build/libpillowfight.so: ${VERSION_FILE} build/Makefile
	(cd build && make -j4)

build/Makefile:
	mkdir -p build
	(cd build && cmake ${CMAKE_OPTS} ..)

${VERSION_FILE}:
	echo -n "#define INTERNAL_PILLOWFIGHT_VERSION \"" >| $@
	echo -n $(shell git describe --always) >> $@
	echo "\"" >> $@

version: ${VERSION_FILE}

doc: install_py
	(cd doc && make html)
	doxygen doc/doxygen.conf
	cp doc/index.html doc/build/index.html

check:
	flake8
# 	pydocstyle src

test: build_py
	tox

linux_exe:

windows_exe:

release:
ifeq (${RELEASE}, )
	@echo "You must specify a release version (make release RELEASE=1.2.3)"
else
	@echo "Will release: ${RELEASE}"
	@echo "Checking release is in ChangeLog ..."
	grep ${RELEASE} ChangeLog | grep -v "/xx"
	@echo "Releasing ..."
	git tag -a ${RELEASE} -m ${RELEASE}
	git push origin ${RELEASE}
	make clean
	make version
	${PYTHON} ./setup.py sdist upload
	@echo "All done"
endif

clean:
	rm -rf doc/build
	rm -rf build dist *.egg-info
	rm -f ${VERSION_FILE}

install_py: ${VERSION_FILE}
	${PYTHON} ./setup.py install ${PIP_ARGS}

install_c: build/Makefile ${VERSION_FILE}
	(cd build && make install)

uninstall_py:
	pip3 uninstall -y pypillowfight

uninstall_c:
	echo "Can't uninstall C library. Sorry"

help:
	@echo "make build || make build_c || make build_py"
	@echo "make check"
	@echo "make doc"
	@echo "make help: display this message"
	@echo "make install || make install_c || make install_py"
	@echo "make release"
	@echo "make test"
	@echo "make uninstall || make uninstall_py"

.PHONY: \
	build \
	build_c \
	build_py \
	check \
	doc \
	exe \
	exe \
	help \
	install \
	install_c \
	install_py \
	release \
	test \
	uninstall \
	uninstall_c \
	version

=== debian/changelog ===
libpillowfight (0.2.4-2) unstable; urgency=medium

  * debian/tests: fix autopkgtests
  * debian/copyright: complete with correct attribution (Closes: #917956)
  * debian/control:
    - add cmake to Build-Depends (Closes: #917987)
    - dump Standards-Version to 4.3.0 (no changes needed)

 -- Thomas Perret <thomas.perret@phyx.fr>  Wed, 02 Jan 2019 11:51:40 +0100

libpillowfight (0.2.4-1) unstable; urgency=medium

  * Initial release (Closes: #912928)

 -- Thomas Perret <thomas.perret@phyx.fr>  Mon, 29 Oct 2018 13:53:46 +0100

=== debian/control ===
Source: libpillowfight
Section: python
Priority: optional
Maintainer: Thomas Perret <thomas.perret@phyx.fr>
Build-Depends: debhelper (>= 11), cmake, dh-python, python3-all, python3-all-dev, python3-setuptools, python3-nose
Standards-Version: 4.3.0
Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libpillowfight
Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libpillowfight
Vcs-Git: https://salsa.debian.org/openpaperwork-team/libpillowfight.git

Package: python3-pypillowfight
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Python 3 bindings for libpillowfight
 Really simple C Library containing various image processing algorithms.
 It includes Python 3 bindings designed to operate on Pillow images.
 .
 This package installs the library for Python 3.

Package: libpillowfight-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpillowfight (= ${binary:Version}), ${misc:Depends}
Description: Various image processing algorithms library - development files
 Really simple C Library containing various image processing algorithms.
 It includes the following algorithms:
  - Unpaper's algorithms: Blackfilter, Noisefilter, Blurfilter, Masks,
 Grayfilter, Border
  - Canny edge detection
  - Sobel operator
  - Gaussian blur
  - ACE (Automatic Color Equalization ; Parallelized implementation)
  - SWT (Stroke Width Transformation)
  - Compare : Compare two images (grayscale) and makes the pixels that are
 different really visible (red).
 .
 This package installs the development headers

Package: libpillowfight
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Various image processing algorithms library
 Really simple C Library containing various image processing algorithms.
 It includes the following algorithms:
  - Unpaper's algorithms: Blackfilter, Noisefilter, Blurfilter, Masks,
 Grayfilter, Border
  - Canny edge detection
  - Sobel operator
  - Gaussian blur
  - ACE (Automatic Color Equalization ; Parallelized implementation)
  - SWT (Stroke Width Transformation)
  - Compare : Compare two images (grayscale) and makes the pixels that are
 different really visible (red).
 .
 This package installs the C library

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME=pypillowfight

src/pillowfight/_version.h: debian/_version.h.in
	sed 's,@DEB_VERSION_UPSTREAM@,$(DEB_VERSION_UPSTREAM),g' $< > $@

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
%:
	dh $@ -p python3-pypillowfight --with python3
	dh $@ -p libpillowfight -p libpillowfight-dev --buildsystem=cmake

override_dh_auto_clean: src/pillowfight/_version.h
	dh_auto_clean
	rm -f src/pillowfight/_version.h

override_dh_auto_test:
	# We disable tests for now because they are not reproductible
	# They tend to produce different results on different machines
	# Upstream is aware of this problem (see https://gitlab.gnome.org/World/OpenPaperwork/libpillowfight/issues/15)
	# dh_auto_test -p python3-pypillowfight -O--buildsystem=pybuild

override_dh_auto_configure: src/pillowfight/_version.h
	dh_auto_configure -p libpillowfight -p libpillowfight-dev -O--buildsystem=cmake -- -DLIBDIR=lib/$(DEB_HOST_MULTIARCH)
	dh_auto_configure -p python3-pypillowfight -O--buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install -p libpillowfight -p libpillowfight-dev -O--buildsystem=cmake
	dh_auto_install -p python3-pypillowfight -O--buildsystem=pybuild

=== debian/tests/control ===
Test-Command: set -e ; for py in $(py3versions -r 2>/dev/null) ; do cd "$ADTTMP" ; echo "Testing with $py:" ; $py -c "import pillowfight; print(pillowfight.__version__)" ; done
Depends: python3-all, python3-pypillowfight
Restrictions: allow-stderr, superficial

## libpillowfight 0.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(libpillowfight)
 set(CMAKE_BUILD_TYPE Release)
-set(LIBDIR lib CACHE STRING "object code libraries directory")
+set(CMAKE_INSTALL_LIBDIR lib CACHE STRING "object code libraries directory")
 
 add_definitions(-DNO_PYTHON)
 include_directories(include)
@@ -18,13 +18,19 @@
     src/pillowfight/_grayfilter.c
     src/pillowfight/_masks.c
     src/pillowfight/_noisefilter.c
+    src/pillowfight/_scanborders.c
     src/pillowfight/_sobel.c
     src/pillowfight/_version.c
     src/pillowfight/util.c
 )
+set_property(TARGET pillowfight PROPERTY SOVERSION 0)
 
-install (TARGETS pillowfight DESTINATION ${LIBDIR})
-install (FILES
+if (UNIX)
+    target_link_libraries(pillowfight m pthread)
+endif (UNIX)
+
+install(TARGETS pillowfight DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(FILES
     include/pillowfight/pillowfight.h
     include/pillowfight/util.h
     DESTINATION

=== debian/changelog ===
libpillowfight (0.3.0-4ubuntu2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:27:03 +0000

libpillowfight (0.3.0-4ubuntu1) jammy; urgency=medium

  * Turn off use of LTO on amd64, which results in a misbuild.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 17 Nov 2021 21:44:34 +0000

libpillowfight (0.3.0-4build3) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Oct 2021 06:56:42 +0000

libpillowfight (0.3.0-4build2) hirsute; urgency=medium

  * No-change rebuild to drop python3.8 extensions.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Dec 2020 18:40:07 +0100

libpillowfight (0.3.0-4build1) hirsute; urgency=medium

  * No-change rebuild to build with python3.9 as supported.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 24 Oct 2020 10:52:46 +0200

libpillowfight (0.3.0-4) unstable; urgency=medium

  * debian/control:
    - bump Standards-Version to 4.5.0 (no changes needed)
    - bump debhelper-compat to 13
  * debian/rules: drop dh_missing override

 -- Thomas Perret <thomas.perret@phyx.fr>  Tue, 18 Aug 2020 20:44:29 +0200

libpillowfight (0.3.0-3) unstable; urgency=medium

  * Make new version (Closes: #945419)
  * debian/salsa-ci.yml: Re-enable build-any Salsa-CI job
  * debian/rules: Add dh_missing --fail-missing

 -- Thomas Perret <thomas.perret@phyx.fr>  Mon, 02 Dec 2019 23:02:46 +0100

libpillowfight (0.3.0-2) UNRELEASED; urgency=medium

  * debian/control: add {lib,}python3-all-dbg package to Build-Depends to also
    build python3 dbgsym package
  * debian/rules: Fix crosscompiling using sbuild and pbuilder

 -- Thomas Perret <thomas.perret@phyx.fr>  Thu, 17 Oct 2019 12:07:22 +0200

libpillowfight (0.3.0-1) unstable; urgency=medium

  * New upstream version 0.3.0
  * debian/control:
    - Rename library package with SONAME version
    - Update library description
      + Add scan borders to available algorithm list
      + Remove complete description from development headers package
  * debian/rules:
    - Allow crossbuilding
    - Explicitly use packages buildsystem in overridden targets
  * Bump Standards-Version to 4.4.1
    - Add Rules-Requires-Root: no to debian/control
    - Move deprecated upstream metadata to debian/copyright
  * Update copyright years and format and fix link (duck hints)
  * Add unittests as DEP-8 autopkgtests
  * Add Salsa CI jobs
  * Remove debian/clean (not needed anymore)

 -- Thomas Perret <thomas.perret@phyx.fr>  Sun, 13 Oct 2019 20:07:28 +0200

=== debian/control ===
Source: libpillowfight
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Perret <thomas.perret@phyx.fr>
Build-Depends: debhelper-compat (= 13), cmake, dh-python, libpython3-all-dev, libpython3-all-dbg, python3-all-dev:any, python3-all-dbg:any, python3-setuptools, python3-nose
Standards-Version: 4.5.0
Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libpillowfight
Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libpillowfight
Vcs-Git: https://salsa.debian.org/openpaperwork-team/libpillowfight.git
Rules-Requires-Root: no

Package: python3-pypillowfight
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Python 3 bindings for libpillowfight
 Really simple C Library containing various image processing algorithms.
 It includes Python 3 bindings designed to operate on Pillow images.
 .
 This package installs the library for Python 3.

Package: libpillowfight-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libpillowfight0 (= ${binary:Version}), ${misc:Depends}
Breaks: libpillowfight (<< ${binary:Version})
Description: Various image processing algorithms library - development files
 Really simple C Library containing various image processing algorithms.
 It includes several image processing algorithms specialized for scanned paper
 described in the library package.
 .
 This package installs the development headers

Package: libpillowfight0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libpillowfight (<< ${binary:Version})
Description: Various image processing algorithms library
 Really simple C Library containing various image processing algorithms.
 It includes the following algorithms:
  - Unpaper's algorithms: Blackfilter, Noisefilter, Blurfilter, Masks,
 Grayfilter, Border
  - Canny edge detection
  - Sobel operator
  - Gaussian blur
  - ACE (Automatic Color Equalization ; Parallelized implementation)
  - SWT (Stroke Width Transformation)
  - Compare : Compare two images (grayscale) and makes the pixels that are
 different really visible (red).
  - Scan borders: Tries to detect the borders of a page in an image coming from
 a scanner.
 .
 This package installs the C library

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

export PYBUILD_NAME=pypillowfight

src/pillowfight/_version.h: debian/_version.h.in
	sed 's,@DEB_VERSION_UPSTREAM@,$(DEB_VERSION_UPSTREAM),g' $< > $@

DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifeq ($(DEB_HOST_ARCH),amd64)
    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif
export DEB_BUILD_MAINT_OPTIONS

%:
	dh $@ --with python3

override_dh_auto_clean: src/pillowfight/_version.h
	dh_auto_clean -p python3-pypillowfight -O--buildsystem=pybuild
	dh_auto_clean -p libpillowfight0 -p libpillowfight-dev -O--buildsystem=cmake
	rm -f src/pillowfight/_version.h

override_dh_auto_configure: src/pillowfight/_version.h
	dh_auto_configure -p python3-pypillowfight -O--buildsystem=pybuild
	dh_auto_configure -p libpillowfight0 -p libpillowfight-dev -O--buildsystem=cmake

override_dh_auto_build:
	dh_auto_build -p python3-pypillowfight -O--buildsystem=pybuild
	dh_auto_build -p libpillowfight0 -p libpillowfight-dev -O--buildsystem=cmake

override_dh_auto_test:
	# We disable tests for now because they are not reproductible
	# They tend to produce different results on different machines
	# Upstream is aware of this problem (see https://gitlab.gnome.org/World/OpenPaperwork/libpillowfight/issues/15)
	# dh_auto_test -p python3-pypillowfight -O--buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install -p python3-pypillowfight -O--buildsystem=pybuild
	dh_auto_install -p libpillowfight0 -p libpillowfight-dev -O--buildsystem=cmake

## libpillowfight 0.3.1

=== Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 # 	pydocstyle src
 
 test: build_py
-	tox
+	pytest -xv tests
 
 linux_exe:

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python3 -m sphinx
SPHINXPROJ    = LibPillowFight
SOURCEDIR     = source
BUILDDIR      = build/sphinx

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
libpillowfight (0.3.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113185)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 19:56:51 +0200

libpillowfight (0.3.1-2) unstable; urgency=medium

  * debian/tests: skip failing tests on i386

 -- Thomas Perret <thomas.perret@phyx.fr>  Sat, 07 Sep 2024 15:46:03 +0200

libpillowfight (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1
  * debian/watch: Fix upstream URL checking
  * debian/patches: drop patches applied in new version
  * debian/copyright: update copyright years
  * debian/control: bump Standards-Version to 4.7.0 (no changes needed)
  * debian/tests: include previously skipped tests

 -- Thomas Perret <thomas.perret@phyx.fr>  Sat, 31 Aug 2024 19:53:07 +0200

libpillowfight (0.3.0-5) unstable; urgency=medium

  * debian/control: dump Build-Depends to 4.6.1
  * debian/copyright: update year
  * debian/control: drop python3-nosetest build dependency (Closes: #1018399)
  * debian/patches:
    + import upstream patch to switch from nose to pytest
    + add debian patch to remove nose from setup.py
  * debian/watch: drop filenamemangling

 -- Thomas Perret <thomas.perret@phyx.fr>  Sun, 18 Sep 2022 12:52:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: libpillowfight
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Thomas Perret <thomas.perret@phyx.fr>
-Build-Depends: debhelper-compat (= 13), cmake, dh-python, libpython3-all-dev, libpython3-all-dbg, python3-all-dev:any, python3-all-dbg:any, python3-setuptools, python3-nose
-Standards-Version: 4.5.0
+Maintainer: Thomas Perret <thomas.perret@phyx.fr>
+Build-Depends: debhelper-compat (= 13), cmake, dh-python, libpython3-all-dev, libpython3-all-dbg, python3-all-dev:any, python3-all-dbg:any, python3-setuptools, python3-pytest
+Standards-Version: 4.7.0
 Homepage: https://gitlab.gnome.org/World/OpenPaperwork/libpillowfight
 Vcs-Browser: https://salsa.debian.org/openpaperwork-team/libpillowfight
 Vcs-Git: https://salsa.debian.org/openpaperwork-team/libpillowfight.git

=== debian/rules ===
--- 
+++ 
@@ -11,12 +11,7 @@
 src/pillowfight/_version.h: debian/_version.h.in
 	sed 's,@DEB_VERSION_UPSTREAM@,$(DEB_VERSION_UPSTREAM),g' $< > $@
 
-DEB_BUILD_MAINT_OPTIONS = hardening=+all
-ifeq ($(DEB_HOST_ARCH),amd64)
-    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
-endif
-export DEB_BUILD_MAINT_OPTIONS
-
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 %:
 	dh $@ --with python3

=== debian/tests/control ===
Test-Command: set -e ; for py in $(py3versions -r 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import pillowfight; print(pillowfight.__version__)" ; done
Depends: python3-all, python3-pypillowfight
Restrictions: allow-stderr, superficial
Features: test-name=import

Tests: unittests
Depends: python3-pypillowfight, python3-pytest, python3-pytest-cov

=== debian/watch ===
version=4
opts=searchmode=plain \
  https://gitlab.gnome.org/World/OpenPaperWork/libpillowfight/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
